namespace org.accordproject.cicero.runtime;
using org.accordproject.cicero.contract;
using org.accordproject.money;
using AccordProject.Concerto;
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.runtime", Version = "0.2.0", Name = "Request")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Request : Transaction {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.runtime@0.2.0.Request";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.runtime", Version = "0.2.0", Name = "Response")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Response : Transaction {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.runtime@0.2.0.Response";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.runtime", Version = "0.2.0", Name = "ErrorResponse")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class ErrorResponse : Transaction {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.runtime@0.2.0.ErrorResponse";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.runtime", Version = "0.2.0", Name = "Obligation")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Obligation : Event {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.runtime@0.2.0.Obligation";
   public AccordContract contract { get; set; }
   public Participant promisor { get; set; }
   public Participant promisee { get; set; }
   public System.DateTime? deadline { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.runtime", Version = "0.2.0", Name = "PaymentObligation")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class PaymentObligation : Obligation {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.runtime@0.2.0.PaymentObligation";
   public MonetaryAmount amount { get; set; }
   public string description { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.runtime", Version = "0.2.0", Name = "NotificationObligation")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class NotificationObligation : Obligation {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.runtime@0.2.0.NotificationObligation";
   public string title { get; set; }
   public string message { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.runtime", Version = "0.2.0", Name = "Payload")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Payload : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.runtime@0.2.0.Payload";
   public AccordContract contract { get; set; }
   public Request request { get; set; }
   public AccordContractState? state { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.runtime", Version = "0.2.0", Name = "Success")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Success : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.runtime@0.2.0.Success";
   public Response response { get; set; }
   public AccordContractState state { get; set; }
   public Event[] emit { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.runtime", Version = "0.2.0", Name = "Failure")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Failure : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.runtime@0.2.0.Failure";
   public ErrorResponse error { get; set; }
}
